#include	<stdio.h>
#include	<pwindow.h>
#include	<signal.h>
#include	<strings.h>
#include	"PwGraph.h"
#include	"PwControl.h"
#include	"PwSignal.h"
#include	"PwToolKit.h"

#define ButtonString	"mF"
#define CW16		8
#define CW24		12
#define CH16		16
#define CH24		24
#define HM		8
#define VM		4

int	ExitFlag = OFF;
PWIN	*DialogWin;
PWGMAP	*StringMap;
PWCNTL	*OkButton;

static PWSIGNAL	sigrec = {-1,(PWIN *)NULL,0,0,0,0};

int	k16_sw = ON;
int	k24_sw = OFF;
int	DialogWidth = -1;
int	DialogHeight = -1;
int	DialogX = -1;
int	DialogY = -1;
char	*DialogString = "";

void	main(argc,argv)
int		argc;
char	*argv[];
{
	PwInitToolKit();		/* c[Lbg */
	GetArgument(argc, argv);	/* 擾 */
	ReadyWin();			/* EBhE */
	MainLoop();			/* VOiE[v */
	TermWin();			/* EBhEI */
}

/*
	擾
*/
int	GetArgument(argc, argv)
int		argc;
char	*argv[];
{
	int	i;
	char	buf[80];
	char	*ptr1 = NULL, *ptr2 = NULL, *ptr3 = NULL;
	
	for (i = 1; i < argc; i++){
		if (argv[i][0] == '-'){
			switch (argv[i][1]){
			case 'k':	/* tHgTCYw */
				if (strncmp(argv[i] + 2, "16", 2) == 0){
					k16_sw = ON;
					k24_sw = OFF;
				}else if (strncmp(argv[i] + 2, "24", 2) == 0){
					k16_sw = OFF;
					k24_sw = ON;
				}
				break;
			case 'g':	/* WIgw -gWxH+X+Y */
				if (argv[i][2] == '\0'){
					i++;
					strncpy(buf, argv[i], sizeof buf);
				}else{
					strncpy(buf, argv[i] + 2, sizeof buf);
				}
				ptr1 = index(buf, 'x');
				if (ptr1 != NULL){
					*ptr1 = '\0';
					ptr2 = index(ptr1 + 1, '+');
				}else{
					ptr2 = buf;
				}
				if (ptr2 != NULL){
					*ptr2 = '\0';
					ptr3 = index(ptr2 + 1, '+');
				}
				if (ptr3 != NULL){
					*ptr3 = '\0';
				}
				if (ptr1 != NULL){
					DialogWidth = atoi(buf);
					DialogHeight = atoi(ptr1 + 1);
				}
				if (ptr3 != NULL){
					DialogX = atoi(ptr2 + 1);
					DialogY = atoi(ptr3 + 1);
				}
				break;
			case '?':	/* wv */
			case 'H':
			case 'h':
				ShowUsage();
				exit(0);
				break;
			default:
				break;
			}
		}else{	/* bZ[W */
			DialogString = argv[i];
		}
	}
}

/*
	EBhE
*/
int	ReadyWin()
{
	if (DialogWidth == -1){	/* ftHg̃_CAOTCY */
		DialogWidth = HM * 2 + \
					strlen(DialogString) * (k16_sw == ON ? CW16 : CW24);
		DialogHeight = VM * 8 + (k16_sw == ON ? CH16 : CH24) * 2;
	}
	if (DialogX == -1){	/* ftHg̃_CAOʒu */
		PwGetMousePosition(PwGetRootWin(), &DialogX, &DialogY);
	}
	
/* _CAOEEBhE */
	DialogWin = PwCreateWin(PwGetRootWin(), DialogX, DialogY, \
							DialogWidth, DialogHeight);
	PwSetWinTitle(DialogWin, "PwDialog");
	PwSetWinAttr(DialogWin, WIN_MP_TITLE|WIN_MP_SCREEN|WIN_SIZE);
	PwSetStdPath(DialogWin, MSK_STDIN|MSK_STDOUT|MSK_STDERR);

/* {^ */
	OkButton = PwCreateButton(DialogWin, \
					DialogWidth / 2 - strlen(ButtonString) * CW16 / 2 - HM, \
					DialogHeight * 3 / 4 - (CH16 + VM * 2) / 2, \
					HM + strlen(ButtonString) * CW16 + HM, \
					VM + CH16 + VM, ButtonString,\
				 	LBL_CLOSED|LBL_POPUP|LBL_GRAY|TS_OUTLINE|TS_PLAIN);
				 	
	write(PwGetWinPath(DialogWin),"\033[1v",4);	/* J[\ */

	if (k16_sw == ON){	/* 16dot bZ[W\ */
		StringMap = PwCreateMap(strlen(DialogString) * CW16, CH16 + VM);
		PwDrawString(StringMap, 0, 0,DialogString, TS_PLAIN);
		PwSetMapWin(StringMap, DialogWin, \
			(DialogWidth - strlen(DialogString) * CW16) / 2, \
			DialogHeight / 4 - (CH16 + VM * 2) / 2, \
			strlen(DialogString) * CW16, CH16 + VM);
	}else{	/* 24dot bZ[W\ */
		StringMap = PwCreateMap(strlen(DialogString) * CW24, CH24 + VM);
		PwDrawString24(StringMap, 0, 0,DialogString, TS_PLAIN);
		PwSetMapWindow(StringMap, PwGetWinPath(DialogWin), \
			(DialogWidth - strlen(DialogString) * CW24) / 2, \
			DialogHeight / 4 - (CH24 + VM * 2) / 2, \
			strlen(DialogString) * CW24, CH24 + VM);
	}
	PwFlushMap(StringMap, FLS_NORMAL);

	PwOpenWin(DialogWin);	/* _CAOEEBhEEI[v */

	PwSelectSignal(DialogWin, WIN_PRESS|WIN_RELEASE);	/* VOiI */

	return 0;
}

/*
	VOiE[v
*/
int	MainLoop()
{
	while(ExitFlag == OFF){	/* VOiE[v */

		PwGetSignal(&sigrec);	/* VOi擾 */

		if (sigrec.win == DialogWin){
			SigDialogWin();	/* VOi */
		}
	}

	return 0;
}

/*
	VOi
*/
int	SigDialogWin()
{
	PWCNTL	*gp;

	gp = PwGetControl(DialogWin, sigrec.x, sigrec.y);
	if (sigrec.type == WIN_PRESS_T){	/* }EX{^EvbV */
		if (gp == OkButton){
			PwSelectButton(gp);
		}
	}else if (sigrec.type == WIN_RELEASE_T){	/* }EX{^E[X */
		if (gp == OkButton){
			if (PwUnSelectButton(gp) == PW_ON_OFF){
				ExitFlag = ON;
			}
		}
	}	
	return 0;
}

/*
	EBhEI
*/
int	TermWin()
{
	PwCloseWin(DialogWin);
	PwDestroyWin(DialogWin);

	return 0;
}

/*
	wv\
*/
int	ShowUsage()
{
	fprintf(stderr, "Usage  : PwDialog -option string\n");
	fprintf(stderr, "Option : -k16    print string with 16x16\n");
	fprintf(stderr, "         -k24    print string with 24x24\n");
	fprintf(stderr, "         -gx+X+Y\n");
}
